package com.scbfkj.uni.api;

import com.scbfkj.uni.library.DataAliasGetUtil;
import com.scbfkj.uni.library.UniReturnUtil;
import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.service.ControlService;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;
import java.util.Optional;

@RestController
@RequestMapping("controlApi")
public class ControlApi {
    @PostMapping("start")
    public ResponseEntity<Map<String, Object>> start( @RequestBody Map<String, Object> body) throws Exception {
        Map<String, Object> started = ControlService.startOrStop(body, "1", false);
        return ResponseEntity.ok(started);
    }

    /**
     * 主动采集与被动采集的停止
     *
     * @param body 请求内容
     * @return
     */
    @PostMapping("stop")
    public ResponseEntity<Map<String, Object>> stop(@RequestBody Map<String, Object> body) throws Exception {
        Map<String, Object> stoped = ControlService.startOrStop(body, "0", false);
        return ResponseEntity.ok(stoped);
    }

    @PostMapping("startAll")
    public ResponseEntity<Map<String, Object>> startAll(@RequestBody Map<String, Object> body) throws Exception {
        Map<String, Object> started = ControlService.startOrStop(body, "1", true);
        return ResponseEntity.ok(started);
    }

    /**
     * 主动采集与被动采集的停止
     *
     * @param body 请求内容
     * @return
     */
    @PostMapping("stopAll")
    public ResponseEntity<Map<String, Object>> stopAll(@RequestBody Map<String, Object> body) throws Exception {
        Map<String, Object> stoped = ControlService.startOrStop(body, "0", true);
        return ResponseEntity.ok(stoped);
    }


    /**
     * 清理缓存
     *
     * @param body 请求内容
     * @return
     */
    @PostMapping("cleanCache")
    public ResponseEntity<Map<String, Object>> cleanCache(@RequestBody Map<String, Object> body) throws Exception {
        Optional<String> table = DataAliasGetUtil.getValue("table", body);
        table.ifPresent(tableName -> {
            List<String> keys = DataBase.cacheDatas.keySet().stream().filter(it -> it.contains(tableName)).toList();
            keys.parallelStream().forEach(DataBase.cacheDatas::remove);
        });
        if (table.isEmpty()) {

            DataBase.cacheDatas.clear();
        }

        return ResponseEntity.ok(UniReturnUtil.success(true));
    }


}
